#################################################
'''
20100312 UTITLTY COVERT CURVE TO MESH
ec @ studiounit6

usage:
curve = cmds.ls(sl=True,type='transform')
print curve2mesh(curve,1,1,"testName")



#DEBUG
polygon = cmds.ls(sl=True,type='transform')
for each in polygon:
	polyUpNormal(each)

'''
#################################################
#import maya.OpenMaya as OpenMaya

def polyUpNormal(object):
	cmds.select(object,r=1)

	# Find face normal
	polyFN = cmds.polyInfo(fn=1)
	tokenize = polyFN[0].split(':')
	normalNum = tokenize[1].strip()
	normalPts = normalNum.split(' ')

	#if face normal.y < 0
	if float(normalPts[1]) < 0:
		#reverse polygon
		cmds.polyNormal(nm=4,ch=0)


def curve2mesh(curve,join,upNormal,newName="mesh"):

	cmds.select(curve,r=1)

	geom = []

	selection = OpenMaya.MSelectionList()
	OpenMaya.MGlobal.getActiveSelectionList(selection)

	iter = OpenMaya.MItSelectionList (selection, OpenMaya.MFn.kNurbsCurve)

	while not iter.isDone():

		status = OpenMaya.MStatus
		dagPath = OpenMaya.MDagPath()
		component = OpenMaya.MObject()

		iter.getDagPath(dagPath, component)

		#print dagPath
		
		iterCrv= OpenMaya.MItCurveCV(dagPath, component)
		
		count2 = OpenMaya.MPointArray()
		meshVertices = OpenMaya.MFloatPointArray()
		polygonConnects = OpenMaya.MIntArray()

		spc = OpenMaya.MSpace.kWorld #doesnt work withough dagpath in iter
		
		
		count = 0
		while not iterCrv.isDone():
			#print iterCrv.index()
			point = iterCrv.position(spc)
			

			count2.append(point)
			meshVertices.append(point.x,point.y,point.z,0.0)
			
			
			polygonConnects.append(count)
			count += 1
			
			iterCrv.next()
			
		#create mesh object
		polygonCounts = OpenMaya.MIntArray()
		polygonCounts.append(meshVertices.length())

			
		#meshVertices2 = OpenMaya.MFloatPointArray()
		#meshVertices2.append(meshVertices)
		
		meshFn = OpenMaya.MFnMesh()
		nullObj = OpenMaya.MObject()
		
		#spc = OpenMaya.MSpace.kObject
		#meshFn.setPoints(meshVertices,spc)
		meshFn.create(meshVertices.length(),1, meshVertices , polygonCounts, polygonConnects, nullObj )
		
		geom.append(meshFn.name())
		iter.next()
	
	if upNormal:
		for each in geom:
			polyUpNormal(each)
	
	if join:
		try:
			returnShape = cmds.polyUnite(geom,ch=0,n=newName+"shape")
			transform = cmds.listRelatives(returnShape,p=1)
			returnName = cmds.rename(transform,newName)
		except:
			cmds.sets(geom,forceElement="initialShadingGroup",e=1)
			transform = cmds.listRelatives(geom[0],p=1)
			returnName = cmds.rename(transform,newName)
	else:
		cmds.sets(geom,forceElement="initialShadingGroup",e=1)
		transform = cmds.listRelatives(geom[0],p=1)
		returnName = cmds.rename(transform,newName)

		
	return returnName
	
#</crv2Mesh>